% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER
%
% computes basis vectors for moment j, on grid knotDistrK (similar to make_h)
function B = basis_mom(js,knotDistrK)
  k = knotDistrK;
  m = length(js);
  B = zeros(length(k)-1,m);
  for i=1:m
    j = js(i);
    y = (k.^(j+1))./(j+1);
    dy = [k(1)^j;diff(y)./diff(k)];
    B(:,i) = dy(2:end)-dy(1);  %since every element i>1 subtracts prob(1)
  end
