% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER
% Pareto distribution:  cf. rich_sl.pdf
%   minimum value of x: xm = C^(1/gam)
%   mean = gam*xm/(gam-1)
%   mean = 1  ==> xm=(gam-1)/gam  ==> C = ((gam-1)/gam)^gam
function p = densy(y,w)
  global Params;
  y = y./w;
  p = zeros(size(y));    
  ispos = (y>=Params.ymin & y<=Params.ymax);
  if(Params.iPareto)
    p(ispos) =  Params.adjDist*Params.gamPareto*Params.CPareto*y(ispos).^(-Params.gamPareto-1);
  else
    p(ispos) = pdf_logn(y(ispos),Params.muY,Params.sigY);
  end
  p = p./w;