% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER
function p = disty(y,w)
  global Params;
  y = y./w;
  
  isbig = (y>=Params.ymax);
  ispos = (y>=Params.ymin & y<Params.ymax);
  p = zeros(size(y));    
  p(isbig) =  1;
  if(Params.iPareto)
    p(ispos) =  Params.adjDist*(1 - Params.CPareto*y(ispos).^(-Params.gamPareto));
  else
    p(ispos) = cdf_logn(y(ispos),Params.muY,Params.sigY);
  end
