% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER
function [R,wage,Transf] = factorprices(Dlag,dz,dtau)
  global Params;

  if(Params.iKS)  %with Krusell/Smith method, aggregate K is first moment:
    Klag = Dlag(1);
  else
    Klag = expect_k(Dlag);
  end
  assert(Klag>0);
  
  R = 1+netintr(Klag,1+dz)-dtau; 
  wage = wagefunc(Klag,1+dz);
  Transf = (Params.taustst+dtau)*Klag;
