% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER
function [p,dp] = idisty(y,w)
  global Params;
  xi = y./w;

  
  isbig = (xi>=Params.splineIF.x(end));
  issma = (xi<=Params.splineIF.x(1));
  ispos = ~(isbig|issma);


  p = zeros(size(xi));    
  dp = zeros(size(xi));    
  

  dp(isbig) =  1;
  dp(issma) =  0;
  p(issma) =  0;
  p(isbig) = Params.splineIF.y(end) + xi(isbig)-Params.splineIF.x(end);
  [p(ispos),dp(ispos)] = evalquadspline(Params.splineIF.x,Params.splineIF.y,Params.splineIF.dy,xi(ispos));


