% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER
% INITIALIZE PARAMETER VALUES SUCH THAT HETSOLVE RUNS

global Params;

% Model parameters:
Params.alpha = 1/3;
Params.beta = 0.95;
Params.delta = 0.1;
Params.gam = 1;
Params.iPareto = 0;  %will be overridden in main.m
Params.gamPareto = 2;
% number of shocks:
Params.nz = 2;
% correlation shocks:
Params.rhoz = 0.8;
Params.rhot = 0.;
Params.iKS = 0;  % will be nonzero for Krusell/Smith method


% Parameters of the approximation:
Params.SmoothDev = 0;
Params.nc = 100;
Params.ny = 41;
Params.ndstst = 1000;
