% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER
%
% compute (assumed one-dimensional) nullspace of sparse matrix M
function D = invdistr(M)
  opts.disp=0;
  eval_wanted = 1;  %eigenvalue for which we need eigenvector
  % for numerical stability, add 1e-10 to this eigenvalue:
  [x,eval] = eigs(M,[],1,eval_wanted+1e-10,opts);
  assert(abs(eval-eval_wanted)<1e-11);
  D = x/sum(x);
  assert(min(D)>-1e-10);
  D = max(D,0);
  D = D/sum(D);
