/* Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
  Michael Reiter, Institute for Advanced Studies, September 2006
  Last update: June 2008
  Feel free to use, copy and modify at your own risk;
    this program comes with NO WARRANTY WHATSOEVER*/
/*
  assumes 
    - xx is in ascending order
    - x is within bounds
  DOES NOT CHECK FOR THIS!!
*/

void huntfast(const double *xx, int n, double x, int *jlo)
{
  int jm,jhi,inc;
  if (x <= xx[1]){
    if (x == xx[1])
      *jlo=1;
    else
      *jlo=0;
    return;
  } else if(x >= xx[n]) {
    if(x > xx[n])
      *jlo=n+1;
    else /* case x==xx[n]: give lower jlo;  */
      *jlo=n-1;
    return;
  } 

  inc=1;
  if (x >= xx[*jlo]) {
    jhi=(*jlo)+1;
    while (x >= xx[jhi]) {
      *jlo=jhi;
      inc += inc;
      jhi=(*jlo)+inc;
      if (jhi > n) {
	jhi=n+1;
	break;
      }
    }
  } else {
    if (*jlo == 1) {
      *jlo=0;
      return;
    }
    jhi=(*jlo)--;
    while (x < xx[*jlo]) {
      jhi=(*jlo);
      inc <<= 1;
      if (inc >= jhi) {
	*jlo=0;
	break;
      }
      else *jlo=jhi-inc;
    }
  }
  while (jhi-(*jlo) != 1) {
    jm=(jhi+(*jlo)) >> 1;
    if (x > xx[jm])
      *jlo=jm;
    else
      jhi=jm;
  }
}

