% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER
% solves discrete Lyapunoff equation
%   S = G1*S*G1' + C*Sig*C'
function Sigma = lyapsym(G1,C,Sig)
  % the doubling algorithm is slow, but very reliable:
  CS = C*Sig*C';
  CS = (CS+CS')/2;
  Sigma = doubling(G1,CS,30);
  % if_ you have the control toolbox, you can use 
  %  the faster dlyap command
  % Sigma = dlyap2(G1,CS);

