% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER


global Params;  % structure which contains all global parameters
% INITIALIZE MOST PARAMETERS:
initparams;



Params.iPareto = 0;  % 1: Pareto; 0: loglinear distribution
Params.gam = 1;  % utility parameter;

% exact model, not the smooth (spline) deviations:
Params.SmoothDev = 0;    

[par,Kequ,D] = hetsolve;
Params2 = Params;
save('ststres','par','Kequ','Params2');
[par,Kequ,D,G1,impact,abseig] = hetsolve(Kequ,par);
save('simsres_ex','par','Kequ','D','G1','impact','abseig');

% now use spline deviations (reduced model):
Params.SmoothDev = 1;
Params.nSpline = 20; %set number of spline bases:
disp(sprintf('now solve reduced model with nSpline = %d',Params.nSpline));

[par,Kequ,D,G1,impact,abseig] = hetsolve(Kequ,par);
save('simsres_spl','par','Kequ','D','G1','impact','abseig');

% compute error variances:
[err_VAR,err_spl,betaVAR] = dosimul;

