% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER
%
% compute H such that moments = H'*x;
function H = make_h(ii,n)
  global Params;
  H = zeros(n,length(ii));
  for j=ii
    h = expect_k([],j);
    m = length(h)-1;
    h2 = h(2:m+1) - h(1);
    if(Params.SmoothDev==1) 
      % m = h'*D = h'*B*x;
      h2 = Params.B'*h2;
    end
    H(1:length(h2),j) = h2;
  end
