% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER
%
% translates the parameters characterizing a distribution into the distribution
%   inverse operation to distr2par
function D =  par2distr(par)
  global Params;

  D = Params.Dstst;
  if(Params.SmoothDev==0)  %par are probabilities
    D(1) = D(1)-sum(par);
    D(2:end) = D(2:end) + par;
  else
    Ddev = Params.B*par; 
    D(1) = D(1) - sum(Ddev);  %deviations sum up to zero!
    D(2:end) = D(2:end) + Ddev;
  end

