% Matlab file for_ paper "Solving Heterogeneous Agent Models by Projection and Perturbation"
% Michael Reiter, Institute for Advanced Studies, September 2006
% Last update: June 2008
% Feel free to use, copy and modify at your own risk;
%   this program comes with NO WARRANTY WHATSOEVER
%
% computes basis vectors for spline basis
function [B,Binv] = splinebasis(knotDistrK,nSpline)
  global Params;

  % transformation G(K):
  knotDG = g_of_k(knotDistrK);
  % knot points for_ spline, in G-space:
  knotGspline = linspace(g_of_k(knotDistrK(2)),g_of_k(Params.kmax),nSpline)';

  a = knotGspline(1);
  b = knotGspline(end);
  B = natcubspline_basis(knotGspline,knotDG(2:end));
  % vector M such that aggregateK = M*p:
  M = basis_mom(1,knotDistrK);
  % projection with constraint that M is preserved:
  Binv = project_constr(B,M);

